/*
 * $RCSfile: gi.h $
 *
 * $Author: marcel $
 *
 * $Revision: 1.4 $
 *
 * $Date: 1995/03/31 00:49:13 $
 *
 * $Locker: marcel $
 *
 * $State: Exp $
 *
 * Amiga version
 *
 * Copyright  1995 Marcel Offermans
 *
 * tabsize = 5
 */

#ifndef RARS_GI_H
#define RARS_GI_H

#ifndef RARS_OS_H
#include "os.h"
#endif

#include <math.h>

const double DEGPRAD = 360.0/(2.0 * PI);

struct colors {int nose, tail;};

enum {
	oBLACK,
	oBLUE,
	oGREEN,
	oCYAN,
	oRED,
	oMAGENTA,
	oBROWN,
	oLIGHTGRAY,
	oDARKGRAY,
	oLIGHTBLUE,
	oLIGHTGREEN,
	oLIGHTCYAN,
	oLIGHTRED,
	oLIGHTMAGENTA,
	oYELLOW,
	oWHITE
};

const int TRACK_COLOR = oDARKGRAY;
const int FIELD_COLOR = oGREEN;
const int TEXT_COLOR  = oBLACK;
const int RAIL_COLOR  = oWHITE;

extern colors car_colors[];
extern colors car_clrs[];

extern double SCALE;
extern double CHR_HGT;
extern double CHR_WID;
extern double X_MAX, Y_MAX;

extern struct Window *window_ptr;
extern BOOL available;

void resume_normal_display(void);
void draw_line(double, double, double, double);
void rectangle(double, double, double, double);
void set_color(int);
void set_fill_color(int);
void flood_fill(double, double);
void text_output(double, double, char *);
void initialize_graphics(void);

void amiga_scoreboard(void);
void amiga_leaders(int);
void amiga_lapper(int, int);

#endif /* RARS_GI_H */
